package base;
//package todo;

import base.Person;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

/**
 * Class Network
 */
public class Network implements Serializable{

  //
  // Fields
  //

  private List<Person> Members; // since the persons have networks, need the networks have persons?
  private List<Task> Tasks;
  private String name;
  
  //
  // Constructors
  //
  public Network (String Name) {
    setName(Name);
    Members = new ArrayList<Person>();
    Tasks = new ArrayList<Task>();
  };
  
  //
  // Methods
  //


  //
  // Accessor methods
  //

  /**
   * Set the value of Members
   * @param newVar the new value of Members
   */
  private void setMembers ( List<Person> newVar ) {
    Members = newVar;
  }

  /**
   * Set the value of Members
   * @param newVar the new value of Members
   */
  public void addMember ( Person newMember ) {
    Members.add(newMember);
  }
  
  /**
   * Get the value of Members
   * @return the value of Members
   */
  public Collection<Person> getMembers ( ) {
    return Members;
  }
  
  /**
   * Get the value of Members
   * @return the value of Members, or null if no such member exists
   */
  public Person getMember (String memberName ) {
    for (Iterator<Person> iterator = Members.iterator(); iterator.hasNext();) {
      Person type = (Person) iterator.next();
      if (type.getName().matches(memberName)) {
        return type;
      }
    }
    return null;
  }
  
  public Boolean contains(String memberName) {
    return (getMember(memberName) != null);
  }

  /**
   * Set the value of Tasks
   * @param newVar the new value of Tasks
   */
  private void setTasks ( List<Task> newVar ) {
    Tasks = newVar;
  }
  
  /**
   * Add a Tasks to this network
   * @param newVar the new tasks
   */
  public void addTask ( Task newVar ) {
    Tasks.add(newVar);
  }

  /**
   * Get the value of Tasks
   * @return the value of Tasks
   */
  public List<Task> getTasks ( ) {
    return Tasks;
  }
  
  /**
   * Returned unclaimed tasks within this network
   * @return List of unclaimed tasks withn this network
   */
  public List<Task> getUnclaimedTasks ( ) {
  	List<Task> allTasks = getTasks(); //remove completed tasks
  	List<Task> allocatedTasks = new ArrayList<Task>();
  	Collection<Person> peeps = getMembers();
  	// Get all allocated (and unfinished) tasks
  	for (Iterator<Person> iterator = peeps.iterator(); iterator.hasNext();) {
			Person person = (Person) iterator.next();
			allocatedTasks.addAll(person.getToDoList());
		}
  	// remove finished tasks from the return array
  	for (Iterator<Task> iterator = allTasks.iterator(); iterator.hasNext();) {
			Task currTask = (Task) iterator.next();
			if (currTask.percentDone() == 100) {
				iterator.remove();
			}
		}
  	// remove all allocated tasks from the return array
  	allTasks.removeAll(allocatedTasks);
    return allTasks;
  }

  //
  // Other methods
  //

  /**
   * Assign all the tasks to all the assignees (by name)
   * .
   * @param        Assignees
   * @param        Tasks
   */
  public void assign( List<String> Assignees, List<Task> Tasks )
  {//TODO: auto generated method stub
  }


  /**
   * @return       int
   */
  public int getPoints(  )
  {
	  return -1;
  }

  /**
   * @param name the name to set
   */
  public void setName(String name) {
    this.name = name;
  }

  /**
   * @return the name
   */
  public String name() {
    return name;
  }


}
