package base;

import base.Task;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.chronicj.Schedule;
import org.chronicj.TemporalExpression;
import org.chronicj.impl.DefaultSchedule;



/**
 * Class Person
 */
public class Person implements Serializable{

  //
  // Fields
  //

  private List<Task> ToDoList;
  private List<Task> finishedtasks;
  private List<Network> networks;
  private String name;
  private Network defaultNetwork;
  //private Schedule mySchedule;
  
  
  //
  // Constructors
  //
  public Person (String name) {
    this.name = name;
	  ToDoList = new ArrayList<Task>();
	  finishedtasks = new ArrayList<Task>();
	  networks = new ArrayList<Network>();
	  defaultNetwork = null;
	  //mySchedule = new DefaultSchedule(); //has a map between events and TE composites which define the recurrence of that event
  };
  
  //
  // Methods
  //


  //
  // Accessor methods
  //
  
  /**
   * Add an item to the ToDoList
   * @param newVar the new value of ToDoList
   */
  private void addToDo ( Task newVar ) {
    ToDoList.add(newVar);
    //mySchedule.add(newVar, TE);
  }
  
  /**
   * Set the value of ToDoList
   * @param newVar the new value of ToDoList
   */
  private void setToDoList ( List<Task> newVar ) {
    ToDoList = newVar;
  }

  /**
   * Get the value of ToDoList
   * @return the value of ToDoList
   */
  public List<Task> getToDoList ( ) {
    return ToDoList;
  }

  //
  // Other methods
  //

  /**
 * @param networks the networks to add
 */
public void addNetwork(Network newNetwork) {
	if (getDefaultNetwork()==null) {
		setDefaultNetwork(newNetwork);
	}
	this.networks.add(newNetwork);
}

/**
 * @param networks the networks to remove
 */
public void removeNetwork(Network network) {
	this.networks.remove(network);
}

/**
 * @param networks the networks to remove
 */
public void removeNetworkByName(String network) {
	for (Iterator<Network> iterator = networks.iterator(); iterator.hasNext();) {
		Network net = iterator.next();
		if (net.name().matches(network))
			this.networks.remove(network);
	}
}

/**
 * @param networks the networks to set
 */
private void setNetwork(List<Network> networks) {
	this.networks = networks;
}

/**
 * @return the networks
 */
public List<Network> getNetworks() {
	return networks;
}

/**
 * @return the networks
 */
public Iterator<Network> getNetworksIt() {
	return networks.iterator();
}

/** Would it be bad if the param was the Task to execute?
   * @param        Task
   * @return True if the passed task existed in this Persons ToDoList, false otherwise.
   */
  public int executeTask( Task Task ) {
	  // if you are gonna handle tasks by their names, then you should use a map. Is this what you want?
	  for (Task ToDo : ToDoList) {
			if (ToDo.getName().matches(Task.getName())||
					ToDo.equals(Task)) {
				finishedtasks.add(ToDo);
				ToDoList.remove(ToDo);
				return ToDo.execute(getName());
			}
	  }
	  return -1;
  }

	public String getName() {
	  return name;
	}
	
	/**
	 * @param defaultNetwork the defaultNetwork to set
	 */
	public void setDefaultNetwork(Network defaultNetwork) {
	  this.defaultNetwork = defaultNetwork;
	}
	
	/**
	 * @return the defaultNetwork
	 */
	public Network getDefaultNetwork() {
	  return defaultNetwork;
	}
	
	public void addTask(Task newTask) {
	  addToDo(newTask);
	  
	}

	public int executeTask(String taskName) {
		Iterator<Task> taskIt = getToDoList().iterator();
		Task currTask = null;
		while (taskIt.hasNext()) {
			currTask = taskIt.next();
			if (currTask.getName().toLowerCase().matches(taskName.toLowerCase())) {
				return executeTask(currTask);
			}
		}
		return -1;
	}


}
